// btm2tad version 0.100
//  BTMemoΥե뷲TADľС 
// (C)Copyright 2003, Yashiro Takeshi

// BtmSegment.h : TAD

#ifndef _DEFINE_H_TADSEGMENT
#define _DEFINE_H_TADSEGMENT

#include <basic.h>
#include <btron/dp.h>
#include <btron/libapp.h>
#include <btron/taddata.h>

#include "AbstractSegment.h"

#pragma pack(1)

class TADSegment : public AbstractSegment<short int> {
public:
  bool isLinkSegment(){
    if (id == 0xffe6){
      return true;
    }
    return false;
  }
};

// ========== ʲϻ¿ʥȤ ==========

// ----------------------------------------------
// 0xA0-00 : ѻ
// 0xA0-00 : ޡ
//           (BtmPageSegmentб)
// ----------------------------------------------
class TADPagePaperSegment : protected TADSegment {
  UB attr;
  UB subid;
public:
  UH length;
  UH width;
  UH top;
  UH bottom;
  UH left;
  UH right;
  TADPagePaperSegment(){
    id = 0xffa0U;
    len = 0x000eU;
    subid = 0;
    attr = 0;
  }
};

class TADPageMarginSegment : protected TADSegment {
  UB attr;
  UB subid;
public:
  UH top;
  UH bottom;
  UH left;
  UH right;
  TADPageMarginSegment(){
    id = 0xffa0U;
    len = 0x000aU;
    subid= 0x01U;
    attr = 0;
  }
};

// ----------------------------------------------
// 0xA2-02 : ʸ
// // 0xA2-00 : եȻ
// // 0xA2-01 : ե°
// //  ܤʸ
//           (BtmFontSegmentб)
// ----------------------------------------------
class TADFontSizeSegment : protected TADSegment {
  UB attr;
  UB subid;
public:
  CHSIZE size;
  TADFontSizeSegment(){
    id = 0xffa2U;
    len = 0x0004U;
    subid = 0x02U;
    attr = 0;
  }
};

/*class TADFontSegment : public TADSegment {
  UB attr;
  UB subid;
public:
  UH _class;
  UB name[0]; // ʤΤȤưääƤޤOK
  TADFontSegment(){
    id = 0xffa2U;
    len = 0x0004U; // name[]Ѥʤ
    subid = 0x00U;
    attr = 0;
  }
};

class TADFontAttrSegment : protected TADSegment {
  UB _attr;
  UB subid;
public:
  UH attr;
  TADFontAttrSegment(){
    id = 0xffa2U;
    len = 0x0004U;
    subid = 0x01U;
    _attr = 0;
  }
};*/

// ----------------------------------------------
// 0xA2-06 : ʸ(BtmTextColorSegmentб)
// ----------------------------------------------
class TADTextColorSegment : protected TADSegment {
  UB attr;
  UB subid;
public:
  COLOR color;
  TADTextColorSegment(){
    id = 0xffa2U;
    len = 0x0006U;
    subid = 0x06U;
    attr = 0;
  }
};

// ----------------------------------------------
// 0xE0 : 󥻥(BtmSegmentInfoSegmentб)
// ----------------------------------------------
class TADSegmentInfoSegment : protected TADSegment {
  UH subid;
  UH sublen;
  UH data;
public:
  TADSegmentInfoSegment(){
    id = 0xffe0U;
    len = 0x0006U;
    subid = 0x0000U;
    sublen = 0x0002U;
    data = 0x0120U; // TAD version 1.20
  }
};

// ----------------------------------------------
// 0xE1 : ʸϳϥ(BtmTextSegmentб)
// ----------------------------------------------
class TADTextSegment : protected TADSegment {
  RECT view;
  RECT draw;
  UNITS h_unit; // 0.1mmñ
  UNITS v_unit; // 0.1mmñ
  UH lang;
  UH bgpat;
public:
  TADTextSegment(){
    id = 0xffe1U;
    len = 0x0018U;
    setrect(view, 0, 0, 0, 0);
    setrect(draw, 0, 0, 0, 0);
    h_unit = 100;
    v_unit = 100;
    lang = 0x0021U;
    bgpat = 0;
  }
};

// ----------------------------------------------
// 0xE2 : ʸϽλ(BtmTextEndSegmentб)
// ----------------------------------------------
class TADTextEndSegment : protected TADSegment {
public:
  TADTextEndSegment(){
    id = 0xffe2U;
    len = 0x0000U;
  }
};

// ----------------------------------------------
// 0xE5 : (̤)
// ----------------------------------------------
/*class TADBitmapSegment : protected TADSegment {
  ;
};*/

// ----------------------------------------------
// 0xE6 : ȥ(BtmLinkSegmentб)
// ----------------------------------------------
class TADLinkSegment : protected TADSegment {
public:
  RECT view;
  H height;
  CHSIZE chsz;
  COLOR frcol;
  COLOR chcol;
  COLOR tbcol;
  COLOR bgcol;
private:
  UH dlen;
  UB data[0];
public:
  TADLinkSegment(){
    id = 0xffe6U;
    len = 0x001eU;
    dlen = 0;
  }
};

#pragma pack(0)

#endif // _DEFINE_H_TADSEGMENT
